"""Cheval.py
Ce programme est sous licence GPL et peut etre copie modifie etc ... librement
sous reserve de toujours mentionner le nom du premier createur,
votre serviteur : Bertrand Belguise
Principe :
a) Balayer la mailbox contenant les messages Dtects comme Spam
b) trouver le premier relais du message
c) Demander a abuse.net l'adresse du postmaster ou de l'abuse (par DNS)
d) regrouper par postmaster les messages en causes
e) envoyer un message de plainte  l'adresse avec copie des messages concerns
f) tenir  jour un score du nombre de messages dont le programme s'est plaint
La configuration est dans le fichier Cheval.ini ainsi que les scores
et eventuels alias au cas ou abuse.net donne de mauvaise indication"""

import ConfigParser
import os
import DNS
import email
import email.Errors
import mailbox
import re
import socket

def msgfactory(fp):
    try:
        return email.message_from_file(fp)
    except email.Errors.MessageParseError:
        # Don't return None since that will
	# stop the mailbox iterator
	return ''


global config
global debug
config=ConfigParser.RawConfigParser()

def SauveConfig():
    cf=open(config.nf,"w")
    config.write(cf)
    cf.close()

def InitialiseConfig():
    import tkFileDialog
    if os.name=="nt":
        config.nf="./Cheval.ini"
    if os.name=="posix":
       config.nf="~/Cheval.ini"
    config.read([config.nf])
    if not config.has_section("Global"):
        config.add_section("Global")
    if not config.has_option("Global","mbox"):
        config.set("Global","mbox",tkFileDialog.askopenfilename(filetypes=[('Mbox de junk','')]))
        SauveConfig()
    if not config.has_option("Global","dns_serveurs"):
        config.set("Global","dns_serveurs","['Ip1','Ip2']")
        SauveConfig()
        print "Editer %s pour initialiser dns_serveurs" % config.nf
        import sys
        sys.exit()
    config.serveurs=eval(config.get("Global","dns_serveurs"))
    if not config.has_section("Aliases"):
        config.add_section("Aliases")
    if not config.has_section("Scores"):
        config.add_section("Scores")
    SauveConfig()

def AdresseAbuse(Domaine):
    """Interroge abuse.net pour obtenir les adresses de plainte ou du getionnaire"""
    Domaine+='.contacts.abuse.net'
    req=DNS.Request(Domaine,qtype='txt',server=config.serveurs)
    ans=None
    while not ans:
        ans=req.req().answers
        Domaine=Domaine[Domaine.find('.')+1:]
    return ans[0]['data']


pattern1=re.compile("(?:from )?(.*)\sby ([^;]*);([^;]*)",re.S)
#Ce pattern eclate la ligne from entre expediteur et recepteur
#pattern2=re.compile("(\S+) *\(*([^\)]*)\)*")
patNom="(?:[a-zA-Z0-9.\-_]+)"
reNom=re.compile(patNom)
#patFqdn="(?:(?:%s\.(?:%s){2,})|(?:unknown))"%(patNom,patNom)
patFqdn="(?:%s\.(?:%s){2,})"%(patNom,patNom)
reFqdn=re.compile(patFqdn)
patIP="\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}"
reIP=re.compile(patIP)
reLigne=re.compile("(%s) *(?:\((%s)(?: +\[(%s)\])*\))*"%(patNom,patNom,patIP))
#pour recuperation du nom dclare et de la partie Identifiee
def meme(Nom1,Nom2):
    if Nom1==Nom2:
        return True
    elif Nom1.split('.')[0]==Nom2.split('.')[0]:
        print "got"
        return True
    else :return False
def Obtient_Chemin(msg):
    """cette procedure a pour ambition de construire
    le chemin suivi par le message en evitant
    les enregistrements Received forges par les
    affreux spameurs"""
    prems=1
    Chemin=[]
    #if debug: print msg.get_all("Received")
    for From in msg.get_all("Received"):
        Match1= pattern1.match(From)
        #if debug : print Match1.group(2),"a recu de ",Match1.group(1)
        if Match1 and Match1.groups():
            NomBy=Match1.group(2)[:Match1.group(2).find(' ')]
            Match2=reLigne.match(Match1.group(1))
            if Match2:
                (Nom,Ident,Ip)=Match2.groups()
            else:
                Nom=Match1.group(1)
                (Ident,Ip)=(None,None)
            if debug :print "Analyse Nom = '%s' Ident = '%s'  Ip = '%s' Nomby='%s'"%(Nom,Ident,Ip,NomBy)
            if not prems:
## Je sors quand la chaine est brisee ou que je n'ai plus d'idetification d'origine
                if not meme(Retenu[0], NomBy) or (Ident==None and Ip==None):
                    break
            prems=0
            Retenu=(Nom,Ident,Ip)
            Chemin.append((Nom,Ident,Ip,NomBy))
            if Ident in [None,'unknown']:break #si on n'a pas identifie l'origine il ya un risque
    if debug:print Chemin
    return Chemin
    
def Obtient_Nom(Saut):
    """Sur un saut du chemin retourne la chaine nom ou adresse valide
    le saut est donn par le tuple Nom annonce,Nom detecte,Ip detectee,par qui"""
    if debug:print "Obtient_Nom ",Saut[0], Saut[1],Saut[2]
    if reFqdn.match(Saut[1]) :
    #remplac le test par vrification si nom est fdqn
        return Saut[1]
    else:
        return Saut[2]
def Est_Adresse_IP(Nom):
    if reIP.match(Nom):
        return True
    else :
        return False

def Procede_Mbox():
    fp=open(config.get("Global","mbox"),'r')
    mbox = mailbox.UnixMailbox(fp, msgfactory)
    if config.has_option("Global","Debug"):
        Debug=eval(config.get("Global","Debug"))
    else:
        Debug=[]
    print Debug
    Nmsg=0
    for msg in mbox:
        if not msg : continue #si le message est vide je sors
        Nmsg+=1
        global debug
        debug= Nmsg in Debug 
        if Procede_Message(msg,Nmsg):
            pass
        else:
            pass
    fp.close()

def Procede_Message(Msg,Num):
    Chemin=Obtient_Chemin(Msg)
    while Chemin:
        Abuse=Obtient_Abuse(Chemin.pop())
        if Abuse :break
    if not Abuse:
        return False
    else:
        print Num,Abuse
        Se_Plaindre(Abuse,Msg)
        if config.has_option("Scores",Abuse):
            config.set("Scores",Abuse,config.getint("Scores",Abuse)+1)
        else:
            config.set("Scores",Abuse,1)
        SauveConfig()

def Obtient_Abuse(Saut):
    Nom= Obtient_Nom(Saut)
    if Est_Adresse_IP(Nom):
        #Traitement par Whois
        return Nom
    else:
##        print "conuslte",Nom
##        retour=AdresseAbuse(Nom)[0]
##        print "retour",retour
        return AdresseAbuse(Nom)[0]
def Se_Plaindre(Aqui,Dequoi):
    pass


InitialiseConfig()
debug=False
Procede_Mbox()


